global elem_type;
global delta_t;
global viscosity;
global n_u_node;
global n_u_node_pos;
global n_u_node_dof;
global n_u_node_real;
global n_p_node;
global n_p_node_pos;
global n_p_node_dof;
global n_elem;
global n_u_node_per_elem;
global n_u_node_per_bdy_elem;
global n_p_node_per_elem;
global n_node_per_bdy_elem;
global n_quad_1d;
global n_quad_2d;
global u_node_type;
global u_node_val;
global u_node_pos;
global u_node_pos_to_val;
global u_node_val_to_dof;
global u_node_force;
global p_node_type;
global p_node_val;
global p_node_pos;
global h_node_val;
global p_node_pos_to_val;
global p_node_val_to_dof;
global elem_u_node_pos;
global elem_p_node_pos;

global elem_u_node_vorticity;   % n_elem x n_u_node_per_elem
global u_node_av_vorticity;     % n_u_node_val x 1
global quad_1d_point;
global quad_1d_weight;
global quad_2d_point;
global quad_2d_weight;
global elem_quad_2d_weight;
global shape_quad;
global shape_quad_1d;
global shape_quad_grad;
global shape_quad_deriv;

global lap_u_bi;
global lap_u_lin;
global grad_p_bi;
global grad_p_lin;
global force_u_lin;
global div_u_bi;
global div_u_lin;
global Transition_matrix;
global grad_eta_inv;
global time_step; % Always start at time_step = 1
global Jacobian;
global Dx;
global Dy;

%% The variables concerning the boundary
global n_bdy_elem; % number of boundary element
% global n_bdy_node; % number of boundary nodes
global n_fixed_bdy_elem; % number of fixed boundary
global normal;
global elem_bdy_node;
global bdy_elem_length;
global bdy_elem_relation;
global global_node_to_bdy_node;
global bdy_node_to_global_node;
global mean_curvature;
global bdy_pressure_node;

global inv_relative_POS;
global inv_POS;
global true_quad_pos;
global type_of_coordinate_system;
global surface_tension;
global elem_fixed_bdy_node;
global fixed_normal;
global fixed_bdy_elem_length;
global fixed_bdy_elem_relation;
global fixed_bdy_pressure_node;
global top_node_order;
global base_node_pos;
global base_quad_1d_point;
global reference_height; % The height of the reference domain in the ALE formulation
global reference_length; % The length of the reference domain in the ALE formulation
global Psi_t_node_val; % The nodal velocity of the ALE map
global force_advection; % The extra forcing from the advection term in the ALE formulation
global surface_bi;
global bdy_forcing;
global surface_tension;
global artificial_viscosity;
global v_node_val;
global q_node_val;
global vorticity;
global Energy;
global Surface_Area;
global Quad_1d_Weight;
global ALPHA; % Newmark method, 1 => the original code
global BETA; % Integration in time, 1 => the original code
global v_t_node_val;

%% Fintie Element Interpretation
global FEM_id;
global FEM_grad;
global FEM_Dx;
global FEM_Dy;
global FEM_two_grad;
global FEM_Dxx;
global FEM_Dxy;
global FEM_Dyy;

%% for time dependent Navier-Stokes
global mass_u_bi;
global mass_u_lin;
global u_dot_grad_u_tri;
global u_dot_grad_u_bi;
global u_dot_grad_u_lin;
global M_h;
global B_h;
global C_h;
global A_h;
global A_lk;

global NODE_INTERIOR;   NODE_INTERIOR = 0;
global NODE_NO_SLIP;    NODE_NO_SLIP = 1;
global NODE_w_DBC;      NODE_w_DBC = 1;
global NODE_EDGE;       NODE_EDGE = 2;
global NODE_w_NBC;      NODE_w_NBC = 2;
global NODE_INFLOW;     NODE_INFLOW = 3;
global NODE_OUTFLOW;    NODE_OUTFLOW = 4;
global NODE_MOVING_BDY; NODE_MOVING_BDY = 5;

global METHOD;
global EULERIAN; EULERIAN = 0;
global LAGRANGIAN; LAGRANGIAN = 1;
global ALE; ALE = 2;
global STOKES; STOKES = 3; % time-dependent Stokes problem (i.e., no convection term)

global Grad_or_Def;
global GRADIENT; GRADIENT = 0;
global DEF; DEF = 1;

global Dirichlet; Dirichlet = 1;
global Neumann; Neumann = 2;
global Robin; Robin = 2;
global Mixed; Mixed = 3;